function platformstate = find_platformconfig(current_lengths,platformstate0,param)

options = optimset('display','iter');
platformstate = fsolve(@residual_forwardproblem,platformstate0,options,current_lengths,param);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function f = residual_forwardproblem(platformstate,current_lengths,param)

alphanow = platformstate(1);
betanow = platformstate(2);
gammanow = platformstate(3);
xGnow = platformstate(4);
yGnow = platformstate(5);
zGnow = platformstate(6);

Rot_total = rotxd(alphanow)*rotyd(betanow)*rotzd(gammanow);
Disp_total = [xGnow; yGnow; zGnow+param.platform_height]; % adding the platform height ...

Tran_total = homogeneous_transform(Rot_total,Disp_total);
Pos_platformpoints_0 = Tran_total*param.Pos_platformpoints_3;

% pause

length1 = norm(Pos_platformpoints_0(1:3,1)-param.Pos_basepoints_0(1:3,1));
length2 = norm(Pos_platformpoints_0(1:3,2)-param.Pos_basepoints_0(1:3,2));
length3 = norm(Pos_platformpoints_0(1:3,3)-param.Pos_basepoints_0(1:3,3));
length4 = norm(Pos_platformpoints_0(1:3,4)-param.Pos_basepoints_0(1:3,4));
length5 = norm(Pos_platformpoints_0(1:3,5)-param.Pos_basepoints_0(1:3,5));
length6 = norm(Pos_platformpoints_0(1:3,6)-param.Pos_basepoints_0(1:3,6));

alllengths = [length1; length2; length3; length4; length5; length6];

f = alllengths.^2-current_lengths.^2;